package com.usky.backend.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.usky.backend.domain.DataRealTime;
import com.usky.backend.domain.MetricItemVo;
import com.usky.backend.domain.StatusVO;
import com.usky.backend.domain.request.LastQueryVo;
import com.usky.backend.domain.response.LastResultVo;
import com.usky.backend.service.DataQueryService;
import com.usky.backend.service.DataRealTimeService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;

@Service
public class DataQueryServiceImpl implements DataQueryService {
    @Autowired
    private DataRealTimeService dataRealTimeService;

    @Override
    public List<LastResultVo> last(LastQueryVo lastQueryVo){
        List<LastResultVo> list = new ArrayList<>();

        List<String> items = lastQueryVo.getMetrics();
        for(int i=0;i<items.size();i++){
            LambdaQueryWrapper<DataRealTime> queryWrapper = Wrappers.lambdaQuery();
            queryWrapper.select(DataRealTime::getAttributeData,DataRealTime::getDataTime)
                    .eq(DataRealTime::getDeviceId,lastQueryVo.getDeviceId())
                    .eq(DataRealTime::getAttributeName,items.get(i));
            DataRealTime one = dataRealTimeService.getOne(queryWrapper);
            List<MetricItemVo> list1 = new ArrayList<>();
            MetricItemVo metric = new MetricItemVo(one.getDataTime(),one.getAttributeData());
            list1.add(metric);
            LastResultVo lastResultVo = new LastResultVo(lastQueryVo.getDeviceId(),items.get(i),list1);
            list.add(lastResultVo);
        }

        return list;
    }

    @Override
    public List<StatusVO> status(){
        List<StatusVO> list = new ArrayList<>();
        QueryWrapper<DataRealTime> query = Wrappers.query();
        query.select("device_id as deviceId","Max(data_time) as maxTime")
                .groupBy("device_id");
        List<Map<String,Object>> maps = dataRealTimeService.listMaps(query);
        if(maps.size()>0) {
            for (int i = 0; i < maps.size(); i++) {
                StatusVO statusVO = new StatusVO(maps.get(i).get("deviceId").toString(),maps.get(i).get("maxTime").toString());
                list.add(statusVO);
            }
        }

        return list;
    }

}
